; GUI #
include win64a.inc
; --------------- 
yrot	equ xrot+4
yspeed	equ xspeed+4
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518

TEXTURE_IMAGE struct
  sizeX		dd ?; Width Of Image In Pixels
  sizeY		dd ?; Height Of Image In Pixels
  data_		dd ?; Texture Data
TEXTURE_IMAGE ends
glPoint struct
	x dd ?
	y dd ?
	z dd ?,?
glPoint ends
glVector struct
	k dd ?
	j dd ?
	i dd ?
	m_Mag dd ?
glVector ends
glFont struct
	m_WindowWidth dq ?
	m_WindowHeight dq ?
	m_ListBase dd ?
	m_FontTexture dd ?
glFont ends
glCamera struct
	vLightSourceToCamera glVector <>
	vLightSourceToIntersect glVector <>
	ptIntersect glPoint <>
	pt glPoint <>
	m_WindowHeight dd ?
	m_WindowWidth dd ?
	m_StreakTexture dd ?
	m_HaloTexture dd ?
	m_GlowTexture dd ?
	m_BigGlowTexture dd ?
	m_MaxPointSize dd ?
	m_Frustum	dd 6*4 dup (?)
	m_LightSourcePos glPoint <>
	m_MaxPitchRate dd ?
	m_MaxHeadingRate dd ?
	m_HeadingDegrees dd ?
	m_PitchDegrees dd ?
	m_MaxForwardVelocity dd ?
	m_ForwardVelocity dd ?
	m_Position glPoint <>
	m_DirectionVector glVector <>
glCamera ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword
local	tex:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	lea	edx,gFont.m_FontTexture
	invoke	glDeleteTextures,1; delete the texture.
	mov	ecx,gFont.m_ListBase
	invoke	glDeleteLists,256; delete the list
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:
	invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:; Check to see if the user pressed any keys.
	mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY	
	cmp	al,VK_W; Is the W key down?
	jne	@f
	movss	xmm0,const_0_2
	invoke	ChangePitch;(-0.2f); Pitch the camera up 0.2 degrees
	jmp	@0
@@:	cmp	al,VK_S; Is the S key down?
	jne	@f
	movss	xmm0,const0_2
	invoke	ChangePitch;(0.2f); Pitch the camera down 0.2 degrees
	jmp	@0	
@@:	cmp	al,VK_D; Is the D key down?
	jne	@f
	movss	xmm0,const0_2
	invoke	ChangeHeading;(0.2f); Yaw the camera to the left
	jmp	@0	
@@:	cmp	al,VK_A; Is the A key down?
	jne	@f
	movss	xmm0,const_0_2
	invoke	ChangeHeading;(-0.2f); Yaw the camera to the right
	jmp	@0	
@@:	cmp	al,VK_Z; Is the Z key down?
	jne	@f
	movr	gCamera.m_ForwardVelocity,0.01; Start moving the camera forward 0.01 units every frame
	jmp	@0	
@@:	cmp	al,VK_C; Is the C key down?
	jne	@f
	movr	gCamera.m_ForwardVelocity,-0.01; Start moving the camera backwards 0.01 units every frame
	jmp	@0	
@@:	cmp	al,VK_X; Is the X key down?
	jne	@f
	and	gCamera.m_ForwardVelocity,0; Stop the camera from moving.
	jmp	@0
@@:	cmp	al,VK_1; Is the 1 key down?
	jne	@f
	mov	infoOn,TRUE; Toggle info on
	jmp	@0	
@@:	cmp	al,VK_2; Is the 2 key down?
        jne	wmBYE
	and	infoOn,FALSE; Toggle info off
@0:	invoke	InvalidateRect,hWin,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;(0.0f, 0.0f, 0.0f, 0.5f; Black Background
	movsd	xmm0,constd1
	invoke	glClearDepth;(1.0f; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations
;-----------------------------------------------------------
	mov	edi,4
@@:	mov	ecx,FileName2[rdi*4]
	mov	edx,FileName3[rdi*4]
	invoke	LoadTexture; Load the font texture
	dec	edi
	jns	@b
;-----------------------------------------------------------
; Make sure it was loaded
; The font class needs to know the window size
        mov	gFont.m_WindowWidth,1024; Set the window size width
	mov	gFont.m_WindowHeight,768; Set the window size height

	movss	xmm0,const1_4
	invoke	BuildFont; Build the font

	movr	gCamera.m_MaxHeadingRate,1.0; Set our Maximum rates for the camera
	movr	gCamera.m_MaxPitchRate,1.0; Set our Maximum rates for the camera
	and	gCamera.m_HeadingDegrees,0; Set our Maximum rates for the camera
; Just create a cylinder that will be used as occluder object
	invoke	glGenLists,1
	mov	cylList,rax
	invoke	gluNewQuadric	
	mov	qobj,rax
	invoke	gluQuadricDrawStyle,eax, GLU_FILL; 
	invoke	gluQuadricNormals,qobj, GLU_SMOOTH;
	invoke	glNewList,cylList, GL_COMPILE;
	invoke	glEnable,GL_COLOR_MATERIAL;
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glColor3f;0, 0, 1
	invoke	glEnable,GL_LIGHT0;
	invoke	glEnable,GL_LIGHTING;
	movss	xmm2,const_2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-2.0
	mov	qword ptr [rsp+28h],5
	mov	qword ptr [rsp+20h],15
	movsd	xmm3,constd4
	movsd	xmm2,constd0_5
	movsd	xmm1,xmm2
	invoke	gluCylinder,qobj
	invoke	glDisable,GL_LIGHTING;
	invoke	glDisable,GL_LIGHT0;
	invoke	glDisable,GL_COLOR_MATERIAL;
	invoke	glEndList;
	invoke	timeGetTime; Get the time the app started
	mov	gStartTime,eax
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
;gCamera.m_WindowHeight = height; The camera needs to know the window height
;gCamera.m_WindowWidth = width; The camera needs to know the window width
	movzx	r8,r9w
	mov	w,r8d
	mov	gCamera.m_WindowWidth,r8d
	shr	r9d,16
	mov	h,r9d
	mov	gCamera.m_WindowHeight,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd1000
	movq	xmm2,constd1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity; Reset The Current Modelview Matrix

; We want our light source to be 50 units if front 
; of the camera all the time to make it look like 
; it is infinately far away from the camera. We only
; do this to the z coordinate because we want to see
; the flares adjust if we fly in a straight line.
	movss	xmm0,gCamera.m_Position.z
	subss	xmm0,const50
	movss	gCamera.m_LightSourcePos.z,xmm0
;##################### NEW STUFF ##########################
; Draw our cylinder and make it "do something"
; Of course we do that BEFORE testing for occlusion
; We need our depth buffer to be filled to check against occluder objects
	invoke	glPushMatrix;
	invoke	glLoadIdentity
	movss	xmm2,const_20
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0, 0, -20.0
	invoke	timeGetTime
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const0_3
	cvtsi2ss xmm0,eax
	divss	xmm0,const50
	invoke	glRotatef;(() / 50.0f, 0.3f, 0.0f, 0.0f;
	invoke	timeGetTime
	xorps	xmm3,xmm3
	movss	xmm2,const0_5
	xorps	xmm1,xmm1
	cvtsi2ss xmm0,eax
	divss	xmm0,const50
	invoke	glRotatef;(timeGetTime() / 50.0f, 0.0f, 0.5f, 0.0f;
	invoke	glCallList,cylList;
	invoke	glPopMatrix;

	invoke	SetPrespective; Set our perspective/oriention on the world
	invoke	RenderLensFlare; Render the lens flare
	invoke	UpdateFrustumFaster; Update the frustum as fast as possible.
	
	cmp	infoOn,TRUE; Check to see if info has been toggled by 1,2
	jnz	@f
	invoke	DrawGLInfo; Info is on so draw the GL information.								
@@:;  
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
glPrintf proc  x:dword, y:dword, set:dword, fmt:dword,params:VARARG
local	text[256]:byte; Holds Our String
local	len:dword

	mov	x,ecx
	mov	y,edx
	or	r9d,r9d;if (Format == NULL)												// If There's No Text
	jz	@f; 
	lea	r8d,params
	mov	edx,r9d;fmt
	lea	ecx,text
	invoke	vsprintf;(, fmt, ap); And Converts Symbols to Actual Numbers
	mov	len,eax
; Parses the String for Variables
; Results are stored in Text
	invoke	glEnable,GL_TEXTURE_2D; Enable 2d Textures
	invoke	glEnable,GL_BLEND; Enable Blending
	invoke	glBlendFunc,GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR
	mov	edx,gFont.m_FontTexture
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Font Texture
	invoke	glDisable,GL_DEPTH_TEST; Disables Depth Testing
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glPushMatrix; Store The Projection Matrix
	invoke	glLoadIdentity; Reset The Projection Matrix
	cvtsi2sd xmm3,gFont.m_WindowHeight
	xorps	xmm2,xmm2
	cvtsi2sd xmm1,gFont.m_WindowWidth
	xorps	xmm0,xmm0
	invoke	glOrtho,,,,,constd_1,constd1; Set Up An Ortho Screen
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glPushMatrix; Store The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix
        xorps	xmm2,xmm2
	cvtsi2ss xmm1,y
	cvtsi2ss xmm0,x
	invoke	glTranslatef;,x,y,0; Position The Text (0,0 - Bottom Left)
	mov	ecx,gFont.m_ListBase
	add	ecx,128-32;set=1
	invoke	glListBase;(m_ListBase-32+(128*set)); Choose The Font Set (0 or 1)
	lea	r8d, text
	mov	ecx,len
	invoke	glCallLists,,GL_UNSIGNED_BYTE; Write The Text To The Screen
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glPopMatrix; Restore The Old Projection Matrix
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glPopMatrix; Restore The Old Projection Matrix
	invoke	glEnable,GL_DEPTH_TEST
	invoke	glDisable,GL_BLEND
	invoke	glDisable,GL_TEXTURE_2D
@@:	leave
	ret
glPrintf endp

ChangePitch proc  degrees:dword
OPTION PROLOGUE:none
	movss	degrees, xmm0

	andps	xmm0,constabs
	movss	xmm1,gCamera.m_MaxPitchRate
	andps	xmm1,constabs
	comiss	xmm0,xmm1
	jbe	@f;if(abs(degrees) < abs(m_MaxPitchRate))
;Our pitch is less than the max pitch rate that we defined so lets increment it.
	movss	xmm0,gCamera.m_PitchDegrees
	addss	xmm0,degrees;m_PitchDegrees += degrees
	jmp	@0
@@:	test	degrees,80000000h
	movss	xmm1,gCamera.m_MaxPitchRate
	jz	@f;if(degrees < 0)
	xorps	xmm1,constxor
;if degrees < 0  We are pitching down so decrement
;if degrees >= 0 We are pitching up so increment
@@:	movss	xmm0,gCamera.m_PitchDegrees
	addss	xmm0,xmm1;gCamera.m_MaxPitchRate
@0:	movss	gCamera.m_PitchDegrees, xmm0
;We don't want our pitch to run away from us. Although it
; really doesn't matter I prefer to have my pitch degrees
; within the range of -360.0f to 360.0f
	comiss	xmm0,const360
	jbe	@f;if(m_PitchDegrees > 360
	subss	xmm0,const360
	jmp	exit0
@@:	comiss	xmm0,const_360
	ja	exit0
	addss	xmm0,const360
exit0:	movss	gCamera.m_PitchDegrees, xmm0
	ret
OPTION PROLOGUE:rbpFramePrologue
ChangePitch endp
ChangeHeading proc degrees:dword
OPTION PROLOGUE:none
	movss	degrees,xmm0
;Our Heading is less than the max heading rate that we 
;defined so lets increment it but first we must check
;to see if we are inverted so that our heading will not
;become inverted.		
	andps	xmm0,constabs
	movsd	xmm1, xmm0
	movss	xmm0,gCamera.m_MaxHeadingRate
	andps	xmm0,constabs
	comiss	xmm0, xmm1
	jbe	@0;if(fabs(degrees) < fabs(m_MaxHeadingRate))
        movss	xmm0,gCamera.m_HeadingDegrees
	movss	xmm1,gCamera.m_PitchDegrees
	comiss	xmm1,const90
	jbe	@f
	comiss	xmm1,const270
	jna	@2
@@:	comiss	xmm1,const_90
	ja	@3
	comiss	xmm1,const_270
	jbe	@3
@2:	subss	xmm0,degrees
	jmp	@7
@3:	addss	xmm0,degrees
	jmp	@7
@0:	test	degrees,80000000h;if(degrees < 0)
	jz	@6
	movss	xmm0,gCamera.m_HeadingDegrees
	movss	xmm1,gCamera.m_PitchDegrees
	comiss	xmm1,const90
	jbe	@f
	comiss	xmm1,const270
	jna	@8
@@:	comiss	xmm1,const_90
	ja	@9
	comiss	xmm1,const_270
	jbe	@9
@8:     addss	xmm0,gCamera.m_MaxHeadingRate
	jmp	@7
; ---------------------------------------------------------------------------
@9:	subss	xmm0,gCamera.m_MaxHeadingRate
	jmp	@7
; ---------------------------------------------------------------------------
@6:     movss	xmm0,gCamera.m_HeadingDegrees
	movss	xmm1,gCamera.m_PitchDegrees
	comiss	xmm1,const90
	jbe	@f
	comiss	xmm1,const270
	jna	@1
@@:	comiss	xmm1,const_90
	ja	@f
	comiss	xmm1,const_270
	jbe	@f
@1:	subss	xmm0,gCamera.m_MaxHeadingRate
	jmp	@7
; ---------------------------------------------------------------------------
@@:	addss	xmm0,gCamera.m_MaxHeadingRate
@7:	movss	gCamera.m_HeadingDegrees, xmm0;;
@5:	movss	xmm0,gCamera.m_HeadingDegrees
	comiss	xmm0,const360
	jbe	@f
	subss	xmm0,const360
	jmp	@4
@@:	comiss	xmm0,const_360
	ja	exit0
	addss	xmm0,const360
@4:	movss	gCamera.m_HeadingDegrees, xmm0
exit0:	ret
OPTION PROLOGUE:rbpFramePrologue
ChangeHeading endp
LoadTexture proc szFileName:dword, texid:dword; Creates Texture From A Bitmap File
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword
local	texture:dword
local	w:dword
local	h:dword
local	buf[20h]:dword

	mov	szFileName,ecx
	mov	texid,edx

	invoke	glGenTextures,1; Create The Texture
	mov	ecx,szFileName
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax;256
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]

	invoke	glPixelStorei,GL_UNPACK_ALIGNMENT,4; Pixel Storage Mode (Word Alignment / 4 Bytes)

; Typical Texture Generation Using Data From The Bitmap
	mov	eax,texid
	mov	edx,[rax]
	invoke	glBindTexture,GL_TEXTURE_2D ; Bind To The Texture ID
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR; Linear Min Filter
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR; Linear Mag Filter

	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,0,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	mov	ecx,texture
	invoke	GlobalFree
	leave
	ret
LoadTexture endp
BuildFont proc Scale:dword
local	cx_:dword; Holds Our X Character Coord
local	cy:dword; Holds Our Y Character Coord
local	old_edi:dword

	mov	old_edi,edi
	movss	Scale,xmm0

	invoke	glGenLists,256
	mov	gFont.m_ListBase,eax; Creating 256 Display Lists
	mov	edx,gFont.m_FontTexture
	or	edx,edx
	jz	exit0 
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Font Texture

	xor	edi,edi; loop<256; loop++); Loop Through All 256 Lists
@@:	mov	eax,edi
	and	eax,15
	cvtsi2ss xmm0,eax
	divss	xmm0,const16
	movss	cx_,xmm0;cx=float(loop%16)/16.0;	 X Position Of Current Character
	mov	eax,edi
	shr	eax,4
	cvtsi2ss xmm0,eax
	divss	xmm0,const16
	movss	cy,xmm0;cy=float(loop/16)/16.0; Y Position Of Current Character

	mov	ecx,gFont.m_ListBase
	add	ecx,edi
	invoke	glNewList,,GL_COMPILE; Start Building A List

	invoke	glBegin,GL_QUADS; Use A Quad For Each Character
	movss	xmm1,const0_9375
	subss	xmm1,cy
	movss	xmm0,cx_
	invoke	glTexCoord2f;(, 1 - cy - 0.0625f); Texture Coord (Bottom Left)
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glVertex2f;(0,0); Vertex Coord (Bottom Left)
	movss	xmm1,const0_9375
	subss	xmm1,cy
	movss	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;(cx + 0.0625f, 1 - cy - 0.0625f); Texture Coord (Bottom Right)
	xorps	xmm1,xmm1
	movss	xmm0,Scale
	mulss	xmm0,const16
	invoke	glVertex2f;(16 * Scale,0); Vertex Coord (Bottom Right)
	movss	xmm1,const1
	subss	xmm1,cy
	movss	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;(cx + 0.0625f, 1 - cy); Texture Coord (Top Right)
	movss	xmm1,Scale
	mulss	xmm1,const16
	movss	xmm0,xmm1
	invoke	glVertex2f;(16 * Scale, 16 * Scale); Vertex Coord (Top Right)
	movss	xmm1,const1
	subss	xmm1,cy
	movss	xmm0,cx_
	invoke	glTexCoord2f;(cx, 1 - cy); Texture Coord (Top Left)
	movss	xmm1,Scale
	mulss	xmm1,const16
	xorps	xmm0,xmm0
	invoke	glVertex2f;(0, 16 * Scale); Vertex Coord (Top Left)
	invoke	glEnd; Done Building Our Quad (Character)
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,Scale
	mulss	xmm0,const10
	invoke	glTranslatef;(10*Scale,0,0); Move To The Right Of The Character
	invoke	glEndList; Done Building The Display List
	inc	edi; Loop Until All 256 Are Built
	cmp	edi,256
	jb	@b
	mov	edi,old_edi
exit0:	leave
	ret
BuildFont endp
SetPrespective proc
local	Matrix[16]:dword; A array to hold the model view matrix.
;local	v0:glVector; A vector to hold our cameras direction * the forward velocity
; we don't want to destory the Direction vector by using it instead.
; Going to use glRotate to calculate our direction vector
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,gCamera.m_HeadingDegrees
	invoke	glRotatef;(m_HeadingDegrees, 0.0f, 1.0f, 0.0f);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,gCamera.m_PitchDegrees
	invoke	glRotatef;(m_PitchDegrees, 1.0f, 0.0f, 0.0f);
; Get the resulting matrix from OpenGL it will have our
; direction vector in the 3rd row.
	lea	edx, Matrix
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX;
; Get the direction vector from the matrix. Element 10 must
; be inverted!
	movss	xmm0,Matrix[8*4]
	movss	xmm1,Matrix[9*4]
	movss	xmm2,Matrix[10*4]
	movss	gCamera.m_DirectionVector.i,xmm0;m_DirectionVector.i = Matrix[8];
	movss	gCamera.m_DirectionVector.j,xmm1;m_DirectionVector.j = Matrix[9];
	xorps	xmm2,constxor
	movss	gCamera.m_DirectionVector.k,xmm2;m_DirectionVector.k = -Matrix[10];

; Ok erase the results of the last computation.
	invoke	glLoadIdentity

; Rotate the scene to get the right orientation.
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,gCamera.m_PitchDegrees
	invoke	glRotatef;1, 0, 0
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,gCamera.m_HeadingDegrees
	invoke	glRotatef;0, 1, 0

; Scale the direction by our speed.
	mov	ecx,offset gCamera.m_DirectionVector
	movups	xmm0,[rcx]
	andps	xmm0,constand0;v0 = m_DirectionVector
	movss	xmm1,gCamera.m_ForwardVelocity
	shufps	xmm1,xmm1,0
	mulps	xmm0,xmm1;v0 *= m_ForwardVelocity
; Increment our position by the vector
	mov	ecx,offset gCamera.m_Position
	movups	xmm1,[rcx]
	addps	xmm1,xmm0
	movups	[rcx],xmm1;m_Position.x += v0
; Translate to our new position.
	xorps	xmm2,xmm2
	subss	xmm2,gCamera.m_Position.z
	xorps	xmm1,xmm1
	subss	xmm1,gCamera.m_Position.y
	xorps	xmm0,xmm0
	subss	xmm0,gCamera.m_Position.x
	invoke	glTranslatef;-m_Position.x, -m_Position.y, -m_Position.z
	leave
	ret
SetPrespective endp
RenderLensFlare proc
local	Length_:dword
local	buf[20h]:dword

	and	Length_,0;GLfloat Length_ = 0.0f;
; Draw the flare only If the light source is in our line of sight
	movss	xmm1,const1
	mov	ecx,offset gCamera.m_LightSourcePos
	invoke	SphereInFrustum
	or	eax,eax;if(SphereInFrustum(m_LightSourcePos, 1.0f) == TRUE)
	jz	@0
;vLightSourceToCamera = m_Position - m_LightSourcePos
	mov	ecx,offset gCamera.m_Position
	mov	edx,offset gCamera.m_LightSourcePos
	movups	xmm0,[rcx]
	movups	xmm1,[rdx]
	subps	xmm0,xmm1
	mov	ecx,offset gCamera.vLightSourceToCamera
	movups	[rcx],xmm0

; Lets compute the vector that points to the camera from the light source.
;Length_ = vLightSourceToCamera.Magnitude()
	invoke	Magnitude
	movss	Length_,xmm0
; Save the length we will need it in a minute
;ptIntersect = m_DirectionVector * Length
;ptIntersect += m_Position;
;vLightSourceToIntersect = ptIntersect - m_LightSourcePos
	movss	xmm0,gCamera.m_DirectionVector.i
        mulss   xmm0,Length_
        addss	xmm0,gCamera.m_Position.x
	movss	gCamera.ptIntersect.x,xmm0;ptIntersect += m_Position;
	subss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.vLightSourceToIntersect.i,xmm0
;ptIntersect = m_DirectionVector * Length
;ptIntersect += m_Position;
;vLightSourceToIntersect = ptIntersect - m_LightSourcePos
	movss	xmm0,gCamera.m_DirectionVector.j
        mulss   xmm0,Length_
	addss	xmm0,gCamera.m_Position.y
	movss	gCamera.ptIntersect.y,xmm0
	subss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.vLightSourceToIntersect.j,xmm0
;ptIntersect = m_DirectionVector * Length
;ptIntersect += m_Position;
;vLightSourceToIntersect = ptIntersect - m_LightSourcePos
	movss	xmm0,gCamera.m_DirectionVector.k
        mulss   xmm0,Length_
	addss	xmm0,gCamera.m_Position.z
	movss	gCamera.ptIntersect.z,xmm0;ptIntersect += m_Position
	subss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.vLightSourceToIntersect.k,xmm0
; Now lets find an point along the cameras direction vector that we can use as an intersection 
;point. Lets translate down this vector the same distance that the camera is away from the light 
;source.
; Lets compute the vector that points to the Intersect point from the light source
	mov	ecx,offset gCamera.vLightSourceToIntersect
	invoke	Magnitude
	movss	Length_,xmm0;Length_ = vLightSourceToIntersect.Magnitude()
; Save the length we will need it later.
;vLightSourceToIntersect.Normalize();// Normalize the vector so its unit length	
	mov	ecx,offset gCamera.vLightSourceToIntersect
	invoke	Normalize; Normalize the vector so its unit length
		
	invoke	glEnable,GL_BLEND; You should already know what this does
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE; You should already know what this does
	invoke	glDisable,GL_DEPTH_TEST; You should already know what this does
	invoke	glEnable,GL_TEXTURE_2D; You should already know what this does
;;;;;/ Differenet Color Glows & Streaks ;;;;;;;;;;/
;;RenderBigGlow(1.0f, 1.0f, 1.0f, 1.0f, m_LightSourcePos, 1.0f);
;;RenderStreaks(1.0f, 1.0f, 0.8f, 1.0f, m_LightSourcePos, 0.7f);
;;
;;RenderBigGlow(1.0f, 0.9f, 1.0f, 1.0f, m_LightSourcePos, 1.0f);
;;RenderStreaks(1.0f, 0.9f, 1.0f, 1.0f, m_LightSourcePos, 0.7f);
;########################## NEW STUFF ##################################
	mov	ecx,offset gCamera.m_LightSourcePos
	invoke	IsOccluded
	or	eax,eax;if (!IsOccluded(m_LightSourcePos));Check if the center of the flare is occluded
	jz	@1;{
; Render the large hazy glow
	mov	eax,gCamera.m_BigGlowTexture
	mov	[rsp+30h],rax
	mov	eax,const16
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.m_LightSourcePos
	mov	[rsp+20h],rax
	movss	xmm3,const1
	movss	xmm2,const0_8
	movss	xmm1,const0_6
	movss	xmm0,xmm1
	invoke	RenderBigGlow;0.6, 0.6, 0.8, 1.0, m_LightSourcePos, 16.0);
; Render the streaks
	mov	eax,gCamera.m_StreakTexture
	mov	[rsp+30h],rax
	mov	eax,const16
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.m_LightSourcePos
	mov	[rsp+20h],rax
	movss	xmm3,const1
	movss	xmm2,const0_8
	movss	xmm1,const0_6
	movss	xmm0,xmm1
	invoke	RenderBigGlow;0.6, 0.6, 0.8, 1.0, m_LightSourcePos, 16.0);
; Render the small Glow
	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const3_5
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.m_LightSourcePos
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const1
	movss	xmm1,const0_8
	movss	xmm0,xmm1
	invoke	RenderBigGlow;0.8, 0.8, 1.0, 0.5, m_LightSourcePos, 3.5);
;			pt = vLightSourceToIntersect * (Length * 0.1f); Lets compute a point that is 20%
	movss	xmm1,const0_1
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const0_6
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_4
	movss	xmm1,const0_6
	movss	xmm0,const0_9
	invoke	RenderBigGlow;(0.9f, 0.6f, 0.4f, 0.5f, pt, 0.6f); Render the small Glow
;pt = vLightSourceToIntersect * (Length * 0.15f); Lets compute a point that is 30%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_15
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0
		
	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const1_7
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_6
	movss	xmm1,const0_5
	movss	xmm0,const0_8
	invoke	RenderBigGlow;(0.8f, 0.5f, 0.6f, 0.5f, pt, 1.7f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.175f); Lets compute a point that is 35%
;pt += m_LightSourcePos; away from the light source in the
	movss	xmm1,const0_175
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0
; direction of the intersection point.
	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const0_83
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_1
	movss	xmm1,const0_2
	movss	xmm0,const0_9
	invoke	RenderBigGlow;0.9f, 0.2f, 0.1f, 0.5f, pt, 0.83f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.285f); Lets compute a point that is 57%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_285
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const1_6
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_4
	movss	xmm1,const0_7
	movss	xmm0,const0_7
	invoke	RenderBigGlow;0.7f, 0.7f, 0.4f, 0.5f, pt, 1.6f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.2755f); Lets compute a point that is 55.1%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_2755
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const0_8
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_2
	movss	xmm1,const0_9
	movss	xmm0,const0_9
	invoke	RenderBigGlow;0.9f, 0.9f, 0.2f, 0.5f, pt, 0.8f); Render the small Glow
;pt = vLightSourceToIntersect * (Length * 0.4775f); Lets compute a point that is 95.5%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_4775
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const1
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_73
	movss	xmm1,const0_82
	movss	xmm0,const0_93
	invoke	RenderBigGlow;0.93f, 0.82f, 0.73f, 0.5f, pt, 1.0f); Render the small Glow
		
;pt = vLightSourceToIntersect * (Length * 0.49f); Lets compute a point that is 98%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_49
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const1_4
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_5
	movss	xmm1,const0_6
	movss	xmm0,const0_7
	invoke	RenderBigGlow;0.7f, 0.6f, 0.5f, 0.5f, pt, 1.4f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.65f); Lets compute a point that is 130%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_65
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const1_8
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_3
	movss	xmm1,const0_8
	movss	xmm0,const0_7
	invoke	RenderBigGlow;0.7f, 0.8f, 0.3f, 0.5f, pt, 1.8f); Render the small Glow
;pt = vLightSourceToIntersect * (Length * 0.63f); Lets compute a point that is 126%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_63
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const1_4
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_2
	movss	xmm1,const0_3
	movss	xmm0,const0_4
	invoke	RenderBigGlow;0.4f, 0.3f, 0.2f, 0.5f, pt, 1.4f); Render the small Glow
;pt = vLightSourceToIntersect * (Length * 0.8f); Lets compute a point that is 160%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_8
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const1_4
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_5
	movss	xmm1,const0_5
	movss	xmm0,const0_7
	invoke	RenderBigGlow;0.7f, 0.5f, 0.5f, 0.5f, pt, 1.4f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.7825f); Lets compute a point that is 156.5%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_7825
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const0_6
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_1
	movss	xmm1,const0_5
	movss	xmm0,const0_8
	invoke	RenderBigGlow;0.8f, 0.5f, 0.1f, 0.5f, pt, 0.6f); Render the small Glow
;pt = vLightSourceToIntersect * (Length * 1.0f); Lets compute a point that is 200%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_HaloTexture
	mov	[rsp+30h],rax
	mov	eax,const1_7
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_6
	movss	xmm1,const0_5
	movss	xmm0,const0_8
	invoke	RenderBigGlow;0.5f, 0.5f, 0.7f, 0.5f, pt, 1.7f); Render the a Halo
;pt = vLightSourceToIntersect * (Length * 0.975f); Lets compute a point that is 195%
;pt += m_LightSourcePos; away from the light source in the
; direction of the intersection point.
	movss	xmm1,const0_975
	mulss   xmm1,Length_
	movss	xmm0,gCamera.vLightSourceToIntersect.i
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.x
	movss	gCamera.pt.x,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.j
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.y
	movss	gCamera.pt.y,xmm0
	movss	xmm0,gCamera.vLightSourceToIntersect.k
	mulss	xmm0,xmm1
	addss	xmm0,gCamera.m_LightSourcePos.z
	movss	gCamera.pt.z,xmm0

	mov	eax,gCamera.m_GlowTexture
	mov	[rsp+30h],rax
	mov	eax,const0_6
	mov	[rsp+28h],rax
	mov	eax,offset gCamera.pt
	mov	[rsp+20h],rax
	movss	xmm3,const0_5
	movss	xmm2,const0_4
	movss	xmm1,const0_6
	movss	xmm0,const0_9
	invoke	RenderBigGlow;0.4f, 0.1f, 0.9f, 0.5f, pt, 2.0f); Render the small Glow
	

@1:	invoke	glDisable,GL_BLEND ; You should already know what this does
	invoke	glEnable,GL_DEPTH_TEST; You should already know what this does
	invoke	glDisable,GL_TEXTURE_2D; You should already know what this does
@0:	leave
	ret
RenderLensFlare endp
UpdateFrustumFaster proc
local	clip[16]:dword
local	proj[16]:dword
local	modl[16]:dword
local	t:dword

; Get the current PROJECTION matrix from OpenGL */
	lea	edx,proj
	invoke	glGetFloatv,GL_PROJECTION_MATRIX
; Get the current MODELVIEW matrix from OpenGL */
	lea	edx, modl
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX
; Combine the two matrices (multiply projection by modelview) 
; but keep in mind this function will only work if you do NOT
; rotate or translate your projection matrix
	movss	xmm0, modl[0*4]
	mulss	xmm0, proj[0*4]
	movss	clip[0*4],xmm0;	clip[0] = modl[0] * proj[0];
	movss	xmm0, modl[1*4]
	mulss	xmm0, proj[5*4]
	movss	clip[1*4],xmm0; clip[1] = modl[1] * proj[5];
	movss	xmm0, modl[2*4]
	mulss	xmm0, proj[10*4]
	movss	xmm1, modl[3*4]
	mulss	xmm1, proj[14*4]
	addss	xmm0,xmm1
	movss	clip[2*4],xmm0;clip[2] = modl[2]*proj[10] + modl[3]*proj[14]
	movss	xmm0, modl[2*4]
	mulss	xmm0, proj[11*4]
	movss	clip[3*4],xmm0;clip[3] = modl[2]*proj[11]
	movss	xmm0, modl[4*4]
	mulss	xmm0, proj[0*4]
	movss	clip[4*4],xmm0;clip[4] = modl[4] * proj[0];
	movss	xmm0, modl[5*4]
	mulss	xmm0, proj[5*4]
	movss	clip[5*4],xmm0;clip[5] = modl[5] * proj[5]
	movss	xmm0, modl[6*4]
	mulss	xmm0, proj[10*4]
	movss	xmm1, modl[7*4]
	mulss	xmm1, proj[14*4]
	addss	xmm0,xmm1
	movss	clip[6*4],xmm0;clip[6] = modl[6]*proj[10] + modl[7]*proj[14];
	movss	xmm0, modl[6*4]
	mulss	xmm0, proj[11*4]
	movss	clip[7*4],xmm0;clip[ 7] = modl[ 6] * proj[11];
	movss	xmm0,modl[8*4]
	mulss	xmm0,proj[0*4]
	movss	clip[8*4],xmm0; clip[ 8] = modl[ 8] * proj[ 0];
	movss	xmm0, modl[9*4]
	mulss	xmm0, proj[5*4]
	movss	clip[9*4],xmm0;clip[ 9] = modl[ 9] * proj[ 5];
	movss	xmm0, modl[10*4]
	mulss	xmm0, proj[10*4]
	movss	xmm1, modl[11*4]
	mulss	xmm1, proj[14*4]
	addss	xmm0,xmm1
	movss	clip[10*4],xmm0;clip[10] = modl[10]*proj[10] + modl[11]*proj[14];
	movss	xmm0, modl[10*4]
	mulss	xmm0, proj[11*4]
	movss	clip[11*4],xmm0;   clip[11] = modl[10] * proj[11];
	movss	xmm0, modl[12*4]
	mulss	xmm0, proj[0*4]
	movss	clip[12*4],xmm0;  clip[12] = modl[12] * proj[ 0];
	movss	xmm0, modl[13*4]
	mulss	xmm0, proj[5*4]
	movss	clip[13*4],xmm0   ; clip[13] = modl[13] * proj[ 5];
	movss	xmm0, modl[14*4]
	mulss	xmm0, proj[10*4]
	movss	xmm1, modl[15*4]
	mulss	xmm1, proj[14*4]
	addss	xmm0,xmm1
	movss	clip[14*4],xmm0;clip[14] = modl[14]*proj[10] + modl[15]*proj[14];
	movss	xmm0, modl[14*4]
	mulss	xmm0, proj[11*4]
	movss	clip[15*4],xmm0;clip[15] = modl[14] * proj[11]
; Extract the numbers for the RIGHT plane 
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[0*4]
	movss	gCamera.m_Frustum[0*10h][0*4],xmm0;m_Frustum[0][0]=clip[3]-clip[0];
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[4*4]
	movss	gCamera.m_Frustum[0*10h][1*4],xmm0;m_Frustum[0][1]=clip[7]-clip[4];
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[8*4]
	movss	gCamera.m_Frustum[0*10h][2*4],xmm0;m_Frustum[0][2]=clip[11]-clip[8]
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[12*4]
	movss	gCamera.m_Frustum[0*10h][3*4],xmm0;m_Frustum[0][3]=clip[15]-clip[12];
; Normalize the result 
	movss	xmm0,gCamera.m_Frustum[0*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[0*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[0*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
;t = GLfloat(sqrt(m_Frustum[0][0]*m_Frustum[0][0]+m_Frustum[0][1]*m_Frustum[0][1]+m_Frustum[0][2] * m_Frustum[0][2]))
	movss	xmm1,gCamera.m_Frustum[0*10h][0*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[0*10h][0*4],xmm1;m_Frustum[0][0] /= t;
	movss	xmm1,gCamera.m_Frustum[0*10h][1*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[0*10h][1*4],xmm1;m_Frustum[0][1] /= t;
	movss	xmm1,gCamera.m_Frustum[0*10h][2*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[0*10h][2*4],xmm1;m_Frustum[0][2] /= t;
	movss	xmm1,gCamera.m_Frustum[0*10h][3*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[0*10h][3*4],xmm1;m_Frustum[0][3] /= t
; Extract the numbers for the LEFT plane 
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[0*4]
	movss	gCamera.m_Frustum[1*10h][0*4],xmm0;m_Frustum[1][0]=clip[3]+clip[0];
	movss	xmm0,clip[7*4]
	addss	xmm0,clip[4*4]
	movss	gCamera.m_Frustum[1*10h][1*4],xmm0;m_Frustum[1][1]=clip[7]+clip[4]
	movss	xmm0,clip[11*4]
	addss	xmm0,clip[8*4]
	movss	gCamera.m_Frustum[1*10h][2*4],xmm0;m_Frustum[1][2] = clip[11] + clip[ 8];
	movss	xmm0,clip[15*4]
	addss	xmm0,clip[12*4]
	movss	gCamera.m_Frustum[1*10h][3*4],xmm0;m_Frustum[1][3] = clip[15] + clip[12];
; Normalize the result 
	movss	xmm0,gCamera.m_Frustum[1*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[1*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[1*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
;t = GLfloat(sqrt( m_Frustum[1][0]*m_Frustum[1][0]+m_Frustum[1][1]*m_Frustum[1][1]+m_Frustum[1][2]*m_Frustum[1][2]))
	movss	xmm1,gCamera.m_Frustum[1*10h][0*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[1*10h][0*4],xmm1;   m_Frustum[1][0] /= t
	movss	xmm1,gCamera.m_Frustum[1*10h][1*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[1*10h][1*4],xmm1;  m_Frustum[1][1] /= t
	movss	xmm1,gCamera.m_Frustum[1*10h][2*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[1*10h][2*4],xmm1; m_Frustum[1][2] /= t
	movss	xmm1,gCamera.m_Frustum[1*10h][3*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[1*10h][3*4],xmm1;m_Frustum[1][3] /= t
; Extract the BOTTOM plane 
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[1*4]
	movss	gCamera.m_Frustum[2*10h][0*4],xmm0;m_Frustum[2][0] = clip[ 3] + clip[ 1];
	movss	xmm0,clip[7*4]
	addss	xmm0,clip[5*4]
	movss	gCamera.m_Frustum[2*10h][1*4],xmm0;m_Frustum[2][1] = clip[ 7] + clip[ 5];
	movss	xmm0,clip[11*4]
	addss	xmm0,clip[9*4]
	movss	gCamera.m_Frustum[2*10h][2*4],xmm0;m_Frustum[2][2] = clip[11] + clip[ 9];
	movss	xmm0,clip[15*4]
	addss	xmm0,clip[13*4]
	movss	gCamera.m_Frustum[2*10h][3*4],xmm0;m_Frustum[2][3] = clip[15] + clip[13];
; Normalize the result 
	movss	xmm0,gCamera.m_Frustum[2*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[2*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[2*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0;t = GLfloat(sqrt(m_Frustum[2][0]*m_Frustum[2][0]+m_Frustum[2][1]*m_Frustum[2][1]+m_Frustum[2][2] *m_Frustum[2][2]))
	movss	xmm1,gCamera.m_Frustum[2*10h][0*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[2*10h][0*4],xmm1;m_Frustum[2][0] /= t;
	movss	xmm1,gCamera.m_Frustum[2*10h][1*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[2*10h][1*4],xmm1;m_Frustum[2][1] /= t;
	movss	xmm1,gCamera.m_Frustum[2*10h][2*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[2*10h][2*4],xmm1;m_Frustum[2][2] /= t;
	movss	xmm1,gCamera.m_Frustum[2*10h][3*4]
	divss	xmm1,xmm0
	movss	gCamera.m_Frustum[2*10h][3*4],xmm1;m_Frustum[2][3] /= t
; Extract the TOP plane */
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[1*4]
	movss	gCamera.m_Frustum[3*10h][0*4],xmm0;m_Frustum[3][0] = clip[ 3] - clip[ 1]
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[5*4]
	movss	gCamera.m_Frustum[3*10h][1*4],xmm0;m_Frustum[3][1] = clip[ 7] - clip[ 5]
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[9*4]
	movss	gCamera.m_Frustum[3*10h][2*4],xmm0;m_Frustum[3][2] = clip[11] - clip[ 9]
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[13*4]
	movss	gCamera.m_Frustum[3*10h][3*4],xmm0;m_Frustum[3][3] = clip[15] - clip[13]
; Normalize the result */
	movss	xmm0,gCamera.m_Frustum[3*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[3*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[3*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0;t=GLfloat(sqrt(m_Frustum[3][0]*m_Frustum[3][0]+m_Frustum[3][1]*m_Frustum[3][1]+m_Frustum[3][2]*m_Frustum[3][2]))
	movss	xmm1,gCamera.m_Frustum[3*10h][0*4]
	divss	xmm1,xmm0;m_Frustum[3][0] /= t
	movss	xmm1,gCamera.m_Frustum[3*10h][1*4]
	divss	xmm1,xmm0;m_Frustum[3][1] /= t
	movss	xmm1,gCamera.m_Frustum[3*10h][2*4]
	divss	xmm1,xmm0;m_Frustum[3][2] /= t
	movss	xmm1,gCamera.m_Frustum[3*10h][3*4]
	divss	xmm1,xmm0;m_Frustum[3][3] /= t
; Extract the FAR plane 
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[2*4]
	movss	gCamera.m_Frustum[4*10h][0*4],xmm0;m_Frustum[4][0] = clip[ 3] - clip[ 2]
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[6*4]
	movss	gCamera.m_Frustum[4*10h][1*4],xmm0;m_Frustum[4][1] = clip[ 7] - clip[ 6]
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[10*4]
	movss	gCamera.m_Frustum[4*10h][2*4],xmm0;m_Frustum[4][2] = clip[11] - clip[10]
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[14*4]
	movss	gCamera.m_Frustum[4*10h][3*4],xmm0;m_Frustum[4][3] = clip[15] - clip[14]
; Normalize the result 
	movss	xmm0,gCamera.m_Frustum[4*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[4*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[4*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0;t=GLfloat(sqrt(m_Frustum[4][0]*m_Frustum[4][0]+m_Frustum[4][1]*m_Frustum[4][1]+m_Frustum[4][2]*m_Frustum[4][2] ))
	movss	xmm1,gCamera.m_Frustum[4*10h][0*4]
	divss	xmm1,xmm0;m_Frustum[4][0] /= t
	movss	xmm1,gCamera.m_Frustum[4*10h][1*4]
	divss	xmm1,xmm0;m_Frustum[4][1] /= t
	movss	xmm1,gCamera.m_Frustum[4*10h][2*4]
	divss	xmm1,xmm0;m_Frustum[4][2] /= t
	movss	xmm1,gCamera.m_Frustum[4*10h][3*4]
	divss	xmm1,xmm0;m_Frustum[4][3] /= t
; Extract the NEAR plane 
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[2*4]
	movss	gCamera.m_Frustum[5*10h][0*4],xmm0;m_Frustum[5][0] = clip[ 3] + clip[2]
	movss	xmm0,clip[7*4]
	addss	xmm0,clip[6*4]
	movss	gCamera.m_Frustum[5*10h][1*4],xmm0;m_Frustum[5][1] = clip[ 7] + clip[ 6]
	movss	xmm0,clip[11*4]
	addss	xmm0,clip[10*4]
	movss	gCamera.m_Frustum[5*10h][2*4],xmm0;m_Frustum[5][2] = clip[11] + clip[10]
	movss	xmm0,clip[15*4]
	addss	xmm0,clip[14*4]
	movss	gCamera.m_Frustum[5*10h][3*4],xmm0;m_Frustum[5][3] = clip[15] + clip[14]
; Normalize the result 
	movss	xmm0,gCamera.m_Frustum[5*10h][0*4]
	mulss	xmm0,xmm0
	movss	xmm1,gCamera.m_Frustum[5*10h][1*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,gCamera.m_Frustum[5*10h][2*4]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0;t=GLfloat(sqrt( m_Frustum[5][0]*m_Frustum[5][0]+m_Frustum[5][1]*m_Frustum[5][1]+m_Frustum[5][2]*m_Frustum[5][2]))
	movss	xmm1,gCamera.m_Frustum[5*10h][0*4]
	divss	xmm1,xmm0;m_Frustum[5][0] /= t
	movss	xmm1,gCamera.m_Frustum[5*10h][1*4]
	divss	xmm1,xmm0;m_Frustum[5][1] /= t
	movss	xmm1,gCamera.m_Frustum[5*10h][2*4]
	divss	xmm1,xmm0;m_Frustum[5][2] /= t
	movss	xmm1,gCamera.m_Frustum[5*10h][3*4]
	divss	xmm1,xmm0;m_Frustum[5][3] /= t;
	leave
	ret
UpdateFrustumFaster endp
DrawGLInfo  proc
local	modelMatrix[16]:dword; This will hold the model view matrix
local	projMatrix[16]:dword; This will hold the projection matrix
local	DiffTime:dword; This is will contain the difference in time
local	String[64]:byte; A temporary string to use to format information
; that will be printed to the screen.
	lea	edx, projMatrix
	invoke	glGetFloatv,GL_PROJECTION_MATRIX; Grab the projection matrix
	lea	edx, modelMatrix
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX; Grab the modelview matrix
; Print out the cameras position
	movss	xmm3,const1
	movss	xmm2,xmm3
	movss	xmm1,xmm3
	movss	xmm0,xmm3
	invoke	glColor4f;1, 1, 1, 1

	cvtss2sd xmm0,gCamera.m_Position.z
	cvtss2sd xmm1,gCamera.m_Position.y
	cvtss2sd xmm2,gCamera.m_Position.x
	movq	qword ptr [rsp+30h],xmm0
	movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt1
	invoke	glPrintf,10,720	
; Print out the cameras direction
	cvtss2sd xmm0,gCamera.m_DirectionVector.k
	cvtss2sd xmm1,gCamera.m_DirectionVector.j
	cvtss2sd xmm2,gCamera.m_DirectionVector.i
	movq	qword ptr [rsp+30h],xmm0
        movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt2
	invoke	glPrintf,10, 700	
; Print out the light sources position	
	cvtss2sd xmm0,gCamera.m_LightSourcePos.z
	cvtss2sd xmm1,gCamera.m_LightSourcePos.y	
	cvtss2sd xmm2,gCamera.m_LightSourcePos.x
	movq	qword ptr [rsp+30h],xmm0
	movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt3
	invoke	glPrintf,10, 680
; Print out the intersection point	
	cvtss2sd xmm0,gCamera.ptIntersect.z
	cvtss2sd xmm1,gCamera.ptIntersect.y
	cvtss2sd xmm2,gCamera.ptIntersect.x
	movq	qword ptr [rsp+30h],xmm0
	movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt4
	invoke	glPrintf,10, 660
; Print out the vector that points from the light source to the camera	
	cvtss2sd xmm0,gCamera.vLightSourceToCamera.k
	cvtss2sd xmm1,gCamera.vLightSourceToCamera.j	
	cvtss2sd xmm2,gCamera.vLightSourceToCamera.i
	movq	qword ptr [rsp+30h],xmm0
	movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt5
	invoke	glPrintf,10, 640
; Print out the vector that points from the light source to the intersection point.	
	cvtss2sd xmm0,gCamera.vLightSourceToIntersect.k
	cvtss2sd xmm1,gCamera.vLightSourceToIntersect.j	
	cvtss2sd xmm2,gCamera.vLightSourceToIntersect.i
	movq	qword ptr [rsp+30h],xmm0
	movq	qword ptr [rsp+28h],xmm1
	movq	qword ptr [rsp+20h],xmm2
	mov	r9d,offset fmt6
	invoke	glPrintf,10, 620
; Let everyone know the below matrix is the model view matrix
	mov	r9d,offset fmt9
	invoke	glPrintf,10, 580	
; Print out row 1 of the model view matrix	
	cvtss2sd xmm0,modelMatrix[3*4]
	cvtss2sd xmm1,modelMatrix[2*4]
	cvtss2sd xmm2,modelMatrix[1*4]	
	cvtss2sd xmm3,modelMatrix[0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 560
; Print out row 2 of the model view matrix	
	cvtss2sd xmm0,modelMatrix[7*4]
	cvtss2sd xmm1,modelMatrix[6*4]
	cvtss2sd xmm2,modelMatrix[5*4]	
	cvtss2sd xmm3,modelMatrix[4*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3;(String, , modelMatrix[4], modelMatrix[5], modelMatrix[6], modelMatrix[7]);
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 540
; Print out row 3 of the model view matrix	
	cvtss2sd xmm0,modelMatrix[11*4]
	cvtss2sd xmm1,modelMatrix[10*4]
	cvtss2sd xmm2,modelMatrix[9*4]	
	cvtss2sd xmm3,modelMatrix[8*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3;(String, , modelMatrix[8], modelMatrix[9], modelMatrix[10], modelMatrix[11]);
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 520
; Print out row 4 of the model view matrix	
	cvtss2sd xmm0,modelMatrix[15*4]
	cvtss2sd xmm1,modelMatrix[14*4]
	cvtss2sd xmm2,modelMatrix[13*4]	
	cvtss2sd xmm3,modelMatrix[12*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 500
; Let everyone know the below matrix is the projection matrix	
	mov	r9d,offset fmt11
	invoke	glPrintf,10, 460
; Print out row 1 of the projection view matrix	
	cvtss2sd xmm0,projMatrix[3*4]
	cvtss2sd xmm1,projMatrix[2*4]
	cvtss2sd xmm2,projMatrix[1*4]	
	cvtss2sd xmm3,projMatrix[0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 440
; Print out row 2 of the projection view matrix	
	cvtss2sd xmm0,projMatrix[7*4]
	cvtss2sd xmm1,projMatrix[6*4]
	cvtss2sd xmm2,projMatrix[5*4]	
	cvtss2sd xmm3,projMatrix[4*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 420
; Print out row 3 of the projection view matrix	
	cvtss2sd xmm0,projMatrix[11*4]
	cvtss2sd xmm1,projMatrix[10*4]
	cvtss2sd xmm2,projMatrix[9*4]	
	cvtss2sd xmm3,projMatrix[8*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt8
	invoke	glPrintf,10, 400
; Print out row 4 of the projection view matrix	
	cvtss2sd xmm0,projMatrix[15*4]
	cvtss2sd xmm1,projMatrix[14*4]
	cvtss2sd xmm2,projMatrix[13*4]	
	cvtss2sd xmm3,projMatrix[12*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt8
	invoke	glPrintf,10, 380
; Let everyone know the below values are the Frustum clipping planes
	mov	r9d,offset fmt10
	invoke	glPrintf,10, 320
; Print out the right clipping plane	
	cvtss2sd xmm0,gCamera.m_Frustum[0*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[0*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[0*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[0*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 300
; Print out the left clipping plane	
	cvtss2sd xmm0,gCamera.m_Frustum[1*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[1*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[1*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[1*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 280
; Print out the bottom clipping plane	
	cvtss2sd xmm0,gCamera.m_Frustum[2*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[2*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[2*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[2*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 260
; Print out the top clipping plane 	
	cvtss2sd xmm0,gCamera.m_Frustum[3*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[3*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[3*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[3*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 240
; Print out the far clipping plane	
	cvtss2sd xmm0,gCamera.m_Frustum[4*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[4*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[4*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[4*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 220
; Print out the near clipping plane	
	cvtss2sd xmm0,gCamera.m_Frustum[5*16][3*4]
	cvtss2sd xmm1,gCamera.m_Frustum[5*16][2*4]
	cvtss2sd xmm2,gCamera.m_Frustum[5*16][1*4]
	cvtss2sd xmm3,gCamera.m_Frustum[5*16][0*4]
	movq	qword ptr [rsp+38h],xmm0
	movq	qword ptr [rsp+30h],xmm1
	movq	qword ptr [rsp+28h],xmm2
	movq	qword ptr [rsp+20h],xmm3
	mov	r9d,offset fmt7
	invoke	glPrintf,10, 200

	cmp	gFrames,100; if we are due for another FPS update
	jb	@f
	invoke	timeGetTime
	mov	gCurrentTime,eax; Get the current time
	sub	eax,gStartTime
	cvtsi2ss xmm0,eax	
	movss	DiffTime,xmm0 ;= GLfloat(gCurrentTime - gStartTime); Find the difference between the start and end times
	cvtsi2ss xmm1,gFrames
	divss	xmm1,xmm0
	mulss	xmm1,const1000
	movss	gFPS,xmm1;gFPS = (gFrames / DiffTime) * 1000.0f; Compute the FPS
	mov	eax,gCurrentTime
	mov	gStartTime,eax;gStartTime = gCurrentTime; Set the current start time to the current time
	mov	gFrames,1; Set the number of frames to 1
	jmp	@2
@@:	inc	gFrames; We are not due to for another update so add one to the frame count
; Print out the FPS
@2:	cvtss2sd xmm0,gFPS
	movq	qword ptr [rsp+20h],xmm0
	lea	r9d,offset fmt12
	invoke	glPrintf,10, 160
	leave
	ret
DrawGLInfo endp
Normalize proc ;glVector1:qword

	cmp	dword ptr [rcx].glVector.m_Mag,0;if(m_Mag != 0.0f)
	jz	exit0
	movss	xmm0,dword ptr [rcx].glVector.m_Mag
        shufps	xmm0,xmm0,0
        movups	xmm1,[rcx]
        divps	xmm1,xmm0
        movups	[rcx],xmm1;v /= m_Mag
Magnitude::		
        movups	xmm0,[rcx]
	mulps	xmm0,xmm0
        movups	xmm1,xmm0
	shufps	xmm1,xmm1,4Eh;10.00.11.10
	addps	xmm0,xmm1
	movups	xmm1,xmm0
	shufps	xmm1,xmm1,11h;00.01.00.01
	addps	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	dword ptr [rcx].glVector.m_Mag, xmm0;m_Mag = GLfloat(sqrt(i * i + j * j + k * k))
exit0:	ret
Normalize endp
SphereInFrustum proc ;p:dword, Radius:dword
	xorps	xmm0,xmm0
	subss	xmm0,xmm1
	movss	xmm2,xmm0;xmm2 = -Radius
	xor	r8,r8
; ---------------------------------------------------------------------------
@0:	lea	eax,gCamera.m_Frustum[r8]
	movss	xmm0, dword ptr	[rax+0*4]
	mulss	xmm0, dword ptr	[rcx].glPoint.x;xmm0=m_Frustum[i][0] * p.x
	movss	xmm1, dword ptr	[rax+1*4]
	mulss	xmm1, dword ptr	[rcx].glPoint.y;xmm1=m_Frustum[i][1] * p.y
	addss	xmm0, xmm1
	movss	xmm1, dword ptr	[rax+2*4]
	mulss	xmm1, dword ptr	[rcx].glPoint.z;xmm1=m_Frustum[i][2] * p.z
	addss	xmm0, xmm1		
	addss	xmm0, dword ptr	[rax+3*4];m_Frustum[i][3]
	comiss	xmm2, xmm0;if(m_Frustum[i][0]*p.x + m_Frustum[i][1]*p.y + m_Frustum[i][2]*p.z + m_Frustum[i][3] <= -Radius)
	jb	@f
	xor	eax,eax;eax=FALSE
	jmp	exit0
; ---------------------------------------------------------------------------
@@:	add	r8d,10h
	cmp	r8d,60h
	jb	@0
; ---------------------------------------------------------------------------
	mov	eax, TRUE
exit0:	retn
SphereInFrustum endp
IsOccluded	proc p:qword
local	viewport[4]:dword
local	mvmatrix[16]:qword
local	projmatrix[16]:qword
local	winx:qword
local	winy:qword
local	winz:qword
local	flareZ:qword
local	bufferZ:dword

	mov	p,rcx
		
	lea	rdx, viewport
	invoke	glGetIntegerv, GL_VIEWPORT
	lea	rdx, mvmatrix
	invoke	glGetDoublev, GL_MODELVIEW_MATRIX
	lea	rdx, projmatrix
	invoke	glGetDoublev, GL_PROJECTION_MATRIX

	lea	rax, winz
	mov	[rsp+40h], rax
	lea	rax, winy
	mov	[rsp+38h], rax
	lea	rax, winx
	mov	[rsp+30h], rax
	lea	rax, viewport
	mov	[rsp+28h], rax
	lea	rax, projmatrix
	mov	[rsp+20h], rax
	lea	r9, mvmatrix
	mov	rax, p
	cvtss2sd xmm2,[rax].glPoint.z
	cvtss2sd xmm1,[rax].glPoint.y
	cvtss2sd xmm0,[rax].glPoint.x
	invoke	gluProject
	movsd	xmm0, winz
	movsd	flareZ, xmm0
	lea	eax, bufferZ
	mov	[rsp+30h], rax
	mov	dword ptr [rsp+28h], GL_FLOAT
	mov	dword ptr [rsp+20h], GL_DEPTH_COMPONENT
	cvttsd2si edx, winy
	cvttsd2si ecx, winx
	invoke	glReadPixels,,,1,1
	cvtss2sd xmm0, bufferZ
	xor	eax,eax
	movsd	xmm1, flareZ
	comisd	xmm1, xmm0
	setna	al
	leave
	retn
IsOccluded	endp
RenderBigGlow proc r:dword, g:dword, b:dword, a:dword, p:dword, scale:dword, texture:dword
local	q[4]:glPoint
local	buf[20h]:dword

	movss	r,xmm0
	movss	g,xmm1
	movss	b,xmm2
	movss	a,xmm3	
; Basically we are just going to make a 2D box from four points we don't need a z coord because
; we are rotating the camera by the inverse so the texture mapped quads will always face us.
        mov	eax, p
	movss	xmm0,[rax].glPoint.x
	subss	xmm0,scale
	movss	q.x[0*(sizeof glPoint)],xmm0;q[0].x = (p.x - scale); Set the x coordinate -scale units from the center point.
	movss	q.x[1*(sizeof glPoint)],xmm0;q[1].x = (p.x - scale); Set the x coordinate -scale units from the center point.
	movss	xmm0,[rax].glPoint.x
	addss	xmm0,scale
	movss	q.x[2*(sizeof glPoint)],xmm0;q[2].x = (p.x + scale); Set the x coordinate scale units from the center point.
	movss	q.x[3*(sizeof glPoint)],xmm0;q[3].x = (p.x + scale); Set the x coordinate scale units from the center point.

	movss	xmm0,[rax].glPoint.y
	subss	xmm0,scale
	movss	q.y[0*(sizeof glPoint)],xmm0;q[0].y = (p.y - scale); Set the y coordinate -scale units from the center point.
	movss	q.y[2*(sizeof glPoint)],xmm0;q[1].y = (p.y + scale); Set the y coordinate scale units from the center point.
	movss	xmm0,[rax].glPoint.y
	addss	xmm0,scale
	movss	q.y[1*(sizeof glPoint)],xmm0;q[2].y = (p.y - scale); Set the y coordinate -scale units from the center point.
	movss	q.y[3*(sizeof glPoint)],xmm0;q[3].y = (p.y + scale); Set the y coordinate scale units from the center point.
		
	invoke	glPushMatrix; Save the model view matrix
        mov	eax, p
        movss	xmm2,[rax].glPoint.z
        movss	xmm1,[rax].glPoint.y
        movss	xmm0,[rax].glPoint.x
	invoke	glTranslatef;(p.x, p.y, p.z); Translate to our point
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,gCamera.m_HeadingDegrees
	invoke	glRotatef;-gCamera.m_HeadingDegrees, 0, 1.0, 0
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	subss	xmm0,gCamera.m_PitchDegrees
	invoke	glRotatef;-gCamera.m_PitchDegrees, 1.0, 0, 0
	mov	edx,texture
	invoke	glBindTexture,GL_TEXTURE_2D; Bind to the Big Glow texture
	movss	xmm3,a
	movss	xmm2,b
	movss	xmm1,g
	movss	xmm0,r
	invoke	glColor4f;r, g, b, a); Set the color since the texture is a gray scale
	
	invoke	glBegin,GL_TRIANGLE_STRIP; Draw the Big Glow on a Triangle Strip
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	movss	xmm1,q.y[0*(sizeof glPoint)]
	movss	xmm0,q.x[0*(sizeof glPoint)]
	invoke	glVertex2f;q[0].x, q[0].y)
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1.0
	movss	xmm1,q.y[1*(sizeof glPoint)]
	movss	xmm0,q.x[1*(sizeof glPoint)]
	invoke	glVertex2f;q[1].x, q[1].y);
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1.0, 0
	movss	xmm1,q.y[2*(sizeof glPoint)]
	movss	xmm0,q.x[2*(sizeof glPoint)]
	invoke	glVertex2f;q[2].x, q[2].y);
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1.0, 1.0
	movss	xmm1,q.y[3*(sizeof glPoint)]
	movss	xmm0,q.x[3*(sizeof glPoint)]
	invoke	glVertex2f;q[3].x, q[3].y);
	invoke	glEnd
	invoke	glPopMatrix; Restore the model view matrix
	leave
	retn
RenderBigGlow endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#44: Lens Flare Tutorial",0
FileName	db "br_Rabbit3.cur",0
BigGlow3	db "BigGlow3.bmp",0
FontBmp		db "Font.bmp",0
Halo3		db "Halo3.bmp",0
HardGlow2       db "HardGlow2.bmp",0
Streaks4	db "Streaks4.bmp",0
FileName2 	dd offset FontBmp,offset HardGlow2,offset BigGlow3,offset Halo3,offset Streaks4
FileName3	dd offset gFont.m_FontTexture,offset gCamera.m_GlowTexture
 dd offset gCamera.m_BigGlowTexture,offset gCamera.m_HaloTexture,offset gCamera.m_StreakTexture

fmt1  db "m_Position............. = %.02f, %.02f, %.02f",0
fmt2  db "m_DirectionVector...... = %.02f, %.02f, %.02f",0
fmt3  db "m_LightSourcePos....... = %.02f, %.02f, %.02f",0
fmt4  db "ptIntersect............ = %.02f, %.02f, %.02f",0
fmt5  db "vLightSourceToCamera... = %.02f, %.02f, %.02f",0
fmt6  db "vLightSourceToIntersect = %.02f, %.02f, %.02f",0
fmt7  db "%.02f, %.02f, %.02f, %.02f",0
fmt8  db "%.02f, %.02f, %.03f, %.03f",0
fmt9  db "GL_MODELVIEW_MATRIX",0
fmt10 db "FRUSTUM CLIPPING PLANES",0
fmt11 db "GL_PROJECTION_MATRIX",0
fmt12 db "FPS %.02f",0
infoOn		db FALSE
gFrames		dd 0
gStartTime	dd ?
gCurrentTime	dd ?
gFPS		dd ?;
qobj		dq ?;the quadric for our cylinder
cylList		dq ?
; Initalize all our member varibles.
gFont		glFont <>
gCamera		glCamera <>
;-----------------------------
;float
const0_01	dd 0.01
const0_02	dd 0.02
const0_0625	dd 0.0625
const0_1	dd 0.1
const0_15	dd 0.15
const0_175	dd 0.175
const0_2	dd 0.2
const_0_2	dd -0.2
const0_2755	dd 0.2755
const0_285	dd 0.285
const0_3	dd 0.3
const0_4	dd 0.4
const0_4775	dd 0.4775
const0_49	dd 0.49
const0_5	dd 0.5
const_0_5	dd -0.5
const0_6	dd 0.6
const0_63	dd 0.63
const0_65	dd 0.65
const0_7	dd 0.7
const0_73	dd 0.73
const0_7825	dd 0.7825
const0_8	dd 0.8
const0_82	dd 0.82
const0_83	dd 0.83
const0_9	dd 0.9
const0_93	dd 0.93
const0_9375	dd 0.9375
const0_975	dd 0.975
const1		dd 1.0
const_1		dd -1.0
const1_4	dd 1.4
const_1_5	dd -1.5
const1_6	dd 1.6
const1_7	dd 1.7
const1_8	dd 1.8
const_2		dd -2.0
const3_5	dd 3.5
const4		dd 4.0
const10		dd 10.0
const_10	dd -10.0
const13_3	dd 13.3
const_13_3	dd -13.3
const16		dd 16.0
const_20	dd -20.0
const_24	dd -24.0
const50		dd 50.0
const90		dd 90.0
const_90	dd -90.0
const270	dd 270.0
const_270	dd -270.0
const360	dd 360.0
const_360	dd -360.0
const1000	dd 1000.0
;double
constd0_5	dq 0.5
constd1		dq 1.0
constd_1	dq -1.0
constd1_3	dq 1.3
constd3		dq 3.0
constd4		dq 4.0
constd45	dq 45.0
constd1000	dq 1000.0
align 16
xrot	dd 0,0,0,0; Y Rotation
xspeed	dd 0,0,0,0; Y Rotation Speed
constabs dd 7FFFFFFFh,7FFFFFFFh,7FFFFFFFh,7FFFFFFFh
constxor dd 80000000h,80000000h,80000000h,80000000h
constand0 dd 0FFFFFFFFh,0FFFFFFFFh,0FFFFFFFFh,0
end